﻿-- Author      : Administrator
-- Create Date : 10/18/2014 2:49:39 PM


local backdrop_move ={ bgFile = "",
						edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 8, edgeSize = 8, 
						insets = { left = 2, right = 2, top = 2, bottom = 2 }};

local function Frame_OnMouseDown(frame)
	frame:StartMoving()
end

local function Frame_OnMouseUp(frame)
	frame:StopMovingOrSizing();
	frame.obj:SaveLocation();
end

local methods = {
	["RefreshSize"] = function(self)
		local width = 0;
		local height = 0;
		
		self.framemain:ClearAllPoints();		
		if iShield_Settings.modelparty then
			height = iShield_Settings.selfsize.height * 8 + iShield_Settings.selfsize.linespace * 7;
			width = iShield_Settings.selfsize.width * 5 + iShield_Settings.selfsize.columnspace * 4;
		else
			height = iShield_Settings.selfsize.height * 5 + iShield_Settings.selfsize.linespace * 4;
			width = iShield_Settings.selfsize.width * 8 + iShield_Settings.selfsize.columnspace * 7;
		end
		
		self.framemain:SetSize(width,height)
		if iShield_Settings.modelinvert then
			if iShield_Settings.modelparty then
				self.framemain:SetPoint("BOTTOMLEFT", "UIParent","BOTTOMLEFT",iShield_Settings.selflocation[1], iShield_Settings.selflocation[2]);
			else
				self.framemain:SetPoint("TOPRIGHT", "UIParent","BOTTOMLEFT",iShield_Settings.selflocation[1], iShield_Settings.selflocation[2]);
			end
		else
			self.framemain:SetPoint("TOPLEFT", "UIParent","BOTTOMLEFT",iShield_Settings.selflocation[1], iShield_Settings.selflocation[2]);
		end
		------------------------bar----
		local i = 1;
		local x = 0;
		local y = 0;
		while i <= 40 do
			local _tempbar = self.barlist[i];
			local _tempbara = self.barlistattach[i];
			_tempbar:ClearAllPoints();
			_tempbara:ClearAllPoints();	
			if iShield_Settings.modelinvert then
				if iShield_Settings.modelparty then
					x = i % 5;
					if x == 0 then
						x = 5;
					end
					x = x - 1;
					x = x * (iShield_Settings.selfsize.width+iShield_Settings.selfsize.columnspace);
					y = 7 - math.ceil(i / 5) + 1;
					y = y * (iShield_Settings.selfsize.height+iShield_Settings.selfsize.linespace);
				else
					x = 7 - math.ceil(i / 5) + 1;
					x = x * (iShield_Settings.selfsize.width+iShield_Settings.selfsize.columnspace);
					y = i % 5;
					if y == 0 then
						y = 5;
					end
					y = y - 1;
					y = y * (iShield_Settings.selfsize.height+iShield_Settings.selfsize.linespace);
				end
			else
				if iShield_Settings.modelparty then
					x = i % 5;
					if x == 0 then
						x = 5;
					end
					x = x - 1;					
					x = x * (iShield_Settings.selfsize.width+iShield_Settings.selfsize.columnspace);
					y = math.ceil(i / 5) - 1;
					y = y * (iShield_Settings.selfsize.height+iShield_Settings.selfsize.linespace);
				else
					x = math.ceil(i / 5) - 1;
					x = x * (iShield_Settings.selfsize.width+iShield_Settings.selfsize.columnspace);
					y = i % 5;
					if y == 0 then
						y = 5;
					end
					y = y - 1;					
					y = y * (iShield_Settings.selfsize.height+iShield_Settings.selfsize.linespace);
				end
			end
			_tempbar:SetTexture(iShield_Settings.color.all[1], iShield_Settings.color.all[2],iShield_Settings.color.all[3],iShield_Settings.color.alpha);		
			_tempbar:SetWidth(iShield_Settings.selfsize.width)
			_tempbar:SetHeight(iShield_Settings.selfsize.height)
			_tempbar:SetPoint("TOPLEFT",self.framemain,"TOPLEFT",x,-y);
			
			
			_tempbara:SetTexture(iShield_Settings.color.magic[1], iShield_Settings.color.magic[2],iShield_Settings.color.magic[3],iShield_Settings.color.alpha);
			_tempbara:SetHeight(iShield_Settings.selfsize.height)
			_tempbara:SetPoint("LEFT",_tempbar,"RIGHT",-1,0);	
			
			i = i + 1;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("RefreshSize end");
	end,
	["RefreshColor"] = function(self)
		local i = 1;
		while i <= 40 do
			self.barlist[i]:SetTexture(iShield_Settings.color.all[1], iShield_Settings.color.all[2],iShield_Settings.color.all[3],iShield_Settings.color.alpha);
			i = i + 1;
		end
	end,
	["SaveLocation"] = function(self)
		if iShield_Settings.modelinvert then
			if iShield_Settings.modelparty  then
				iShield_Settings.selflocation[1] = self.framemain:GetLeft();
				iShield_Settings.selflocation[2] = self.framemain:GetBottom();
			else
				iShield_Settings.selflocation[1] = self.framemain:GetRight();
				iShield_Settings.selflocation[2] = self.framemain:GetTop();
			end
		else			
			iShield_Settings.selflocation[1] = self.framemain:GetLeft();
			iShield_Settings.selflocation[2] = self.framemain:GetTop();
		end
	end,
	["BarVisible"] = function(self,value)		
		if value then
			local i = 1;
			while i <= 40 do
				self.barlist[i]:SetWidth(iShield_Settings.selfsize.width);
				self.barlist[i]:Show();
				self.barlistattach[i]:Hide();
				i = i + 1;
			end
		else
			local i = 1;
			while i <= 40 do
				self.barlist[i]:SetWidth(1);
				self.barlist[i]:Hide();
				self.barlistattach[i]:Hide();
				i = i + 1;
			end
		end
		--DEFAULT_CHAT_FRAME:AddMessage("BarVisible end");
	end,
	["LockFrame"] = function(self,value)
		if value then
			self.framemain:SetMovable(false);
			self.framemain:EnableMouse(false);
			self.framemain:SetBackdrop(nil);
			self:BarVisible(false);
			local i = 1;
			while i <= 13 do
				self.barlabel[i]:Hide();
				i = i + 1;
			end
		else
			self.framemain:SetMovable(true);
			self.framemain:EnableMouse(true);
			self.framemain:SetBackdrop(backdrop_move);
			self:BarVisible(true);
			local i = 1;
			while i <= 13 do
				self.barlabel[i]:Show();
				i = i + 1;
			end
		end
	end,
	["Cernter"] = function(self)
		self.framemain:ClearAllPoints();
		if iShield_Settings.modelinvert then
			if iShield_Settings.modelparty then
				self.framemain:SetPoint("BOTTOMLEFT", "UIParent","CENTER");
			else
				self.framemain:SetPoint("TOPRIGHT", "UIParent","CENTER");
			end
		else
			self.framemain:SetPoint("TOPLEFT", "UIParent","CENTER");
		end
	end,
	["PrintValue"] =  function(self,id,all,physical,magic)
		if all > 1 then
			all = 1;
		end
		if (magic + all) > 1 then
			magic = 1 - all;
		end
		if (physical + all) > 1 then
			physical = 1 - all;
		end
		
		if all == 0 then
			if self.barlist[id]:IsShown() then
				self.barlist[id]:Hide();
				self.barlist[id]:SetWidth(1);
			end
		else
			local val_all = all * iShield_Settings.selfsize.width;
			self.barlist[id]:SetWidth(val_all);
			if self.barlist[id]:IsShown() then
			else
				self.barlist[id]:Show();
			end
		end
		
		if magic > 0 or physical > 0 then
			local val_all = (magic + physical) * iShield_Settings.selfsize.width;
			self.barlistattach[id]:SetWidth(val_all);
			if self.barlistattach[id]:IsShown() then
			else
				self.barlistattach[id]:Show();
			end
			if magic > 0 then
				self.barlistattach[id]:SetTexture(iShield_Settings.color.magic[1], iShield_Settings.color.magic[2],iShield_Settings.color.magic[3],iShield_Settings.color.alpha);
			else
				self.barlistattach[id]:SetTexture(iShield_Settings.color.physical[1], iShield_Settings.color.physical[2],iShield_Settings.color.physical[3],iShield_Settings.color.alpha);
			end
		else
			if self.barlistattach[id]:IsShown() then
				self.barlistattach[id]:Hide();
			end
		end
	end
}


function iShieldMainFrame()
	local framemain = CreateFrame("Frame","mainFrame",UIParent)
	local barlist = {};
	local barlistattach = {};
	local barlabel = {};
	do
		local i = 1;
		while i <= 40 do
			local _tempbar = CreateFrame("Frame",nil,framemain)		
			_tempbar:SetFrameStrata("HIGH")
			_tempbar:SetWidth(iShield_Settings.selfsize.width) 
			_tempbar:SetHeight(iShield_Settings.selfsize.height)
			local _temp = _tempbar:CreateTexture(nil,"BACKGROUND");
			_temp:SetAllPoints(_tempbar);
			_tempbar.texture = _temp;
			
			local _tempbara = CreateFrame("Frame",nil,framemain)		
			_tempbara:SetFrameStrata("HIGH")
			_tempbara:SetWidth(iShield_Settings.selfsize.width) 
			_tempbara:SetHeight(iShield_Settings.selfsize.height)
			local _tempa = _tempbara:CreateTexture(nil,"BACKGROUND");
			_tempa:SetAllPoints(_tempbara);
			_tempbara.texture = _tempa;
			
			barlist[i] = _temp;
			barlistattach[i] = _tempa;
			i = i + 1;
		end
	end
	do
		local i = 1;
		local j = 2;
		while i <= 5 do
			local _tmplablel = framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
			_tmplablel:SetPoint("TOPLEFT",barlist[i],"TOPLEFT");
			_tmplablel:SetJustifyH("LEFT")
			_tmplablel:SetText("|cffffffff1:"..tostring(i).."("..tostring(i)..")|r");
			barlabel[i] = _tmplablel;
			i = i + 1;
		end
		while j <=8 do
			local _tmpindex = (j - 1) * 5 + 1;
			
			local _tmplablel = framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
			_tmplablel:SetPoint("TOPLEFT",barlist[_tmpindex],"TOPLEFT");
			_tmplablel:SetJustifyH("LEFT")
			_tmplablel:SetText("|cffffffff"..tostring(j)..":1("..tostring(_tmpindex)..")|r");
			barlabel[i] = _tmplablel;
			i = i + 1;
			j = j + 1;
		end		
		barlabel[13] = framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
		barlabel[13]:SetPoint("TOPLEFT",barlist[40],"TOPLEFT");
		barlabel[13]:SetJustifyH("LEFT")
		barlabel[13]:SetText("|cffffffff8:5(40)|r");
	end
	framemain:SetWidth(16)
	framemain:SetHeight(16)
	framemain:SetMovable(false);
	framemain:EnableMouse(false);
	framemain:SetToplevel(1);
	framemain:SetScript("OnMouseUp",Frame_OnMouseUp);
	framemain:SetScript("OnMouseDown",Frame_OnMouseDown);
	framemain:Hide();
	local widget = {
		framemain = framemain,
		barlist = barlist,
		barlistattach = barlistattach,
		barlabel = barlabel
	}
	for method, func in pairs(methods) do
		widget[method] = func
	end
	framemain.obj = widget
	return widget
end