﻿-- Author      : Administrator
-- Create Date : 10/19/2014 1:32:13 AM

local L10N = iShieldDB_Translations
local configSliderBackdrop  = {
	bgFile = "Interface\\Buttons\\UI-SliderBar-Background",
	edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
	tile = true, tileSize = 8, edgeSize = 8,
	insets = { left = 3, right = 3, top = 6, bottom = 6 }
}
local configFrameBackdrop ={ bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
						edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 11, right = 12, top = 12, bottom = 11 }};
						
local function Config_OnMouseDown(frame)
	frame:StartMoving()
end

local function Config_OnMouseUp(frame)
	frame:StopMovingOrSizing()
end

local function BTExit_OnClick()
	iShieldOptionsSimpleVisible()
end

local function BTMore_OnClick()
	iShieldOptionsVisible()
end

local function CBDouble_OnClick(frame)
	if frame:GetChecked() then
		iShield_Settings.backup.enabledflag = true;
	else
		iShield_Settings.backup.enabledflag = false;
	end
	iShieldButtonChange();	
end

local function Bar_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= iShield_Settings.selfsize[_frame.obj] then
		iShield_Settings.selfsize[_frame.obj] = nowVal;
		iShieldFrameSizeChange();
	end
end

local function BarButtonLoc_OnScrollValueChanged(_frame, _value)
	local nowVal =  math.ceil(_value);
	if nowVal ~= iShield_Settings.buttonLoc[_frame.obj] then
		iShield_Settings.buttonLoc[_frame.obj] = nowVal;
		iShieldButtonChange();
	end
end

local methods = {
	["LoaderUserData"] = function(self)	
		self.checkboxdouble:SetChecked(iShield_Settings.backup.enabledflag);
		self.barheight:SetValue(iShield_Settings.selfsize.height);
		self.barwidth:SetValue(iShield_Settings.selfsize.width);
		self.barline:SetValue(iShield_Settings.selfsize.linespace);
		self.barcolumn:SetValue(iShield_Settings.selfsize.columnspace);		
		self.barbuttonloc:SetValue(iShield_Settings.buttonLoc.location);
		self.brbuttonlocspace:SetValue(iShield_Settings.buttonLoc.space);
	end
}
function iShieldOptionsSimple()
	local framemain = CreateFrame("Frame","Config",UIParent)
	framemain:SetWidth(350)
	framemain:SetHeight(240)
	framemain:SetMovable(1);
	framemain:EnableMouse(1);
	framemain:SetToplevel(1);
	framemain:SetBackdrop(configFrameBackdrop);
	framemain:SetPoint("CENTER","UIParent","CENTER");
	framemain:SetScript("OnMouseUp",Config_OnMouseUp);
	framemain:SetScript("OnMouseDown",Config_OnMouseDown);
	framemain:Hide();

	local labelTitle =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelTitle:SetPoint("TOP", 0, -20)
	labelTitle:SetJustifyH("LEFT")
	labelTitle:SetJustifyV("TOP")
	labelTitle:SetText("|cffff0000iShield|r");
	
	local buttonexit = CreateFrame("Button", nil, framemain, "UIPanelButtonTemplate");
	buttonexit:SetScript("OnClick", BTExit_OnClick);
	buttonexit:SetPoint("BOTTOM",framemain,"BOTTOM",0,16);
	buttonexit:SetHeight(20);
	buttonexit:SetWidth(80);
	buttonexit:SetText(L10N.OptSExit);

	local buttonmore = CreateFrame("Button", nil, framemain, "UIPanelButtonTemplate");
	buttonmore:SetScript("OnClick", BTMore_OnClick);
	buttonmore:SetPoint("TOPLEFT",20, -50);
	buttonmore:SetHeight(20);
	buttonmore:SetWidth(100);
	buttonmore:SetText(L10N.OptSMoreOptions);
	---------------------------------------------------	
	
	local checkboxdouble = CreateFrame("CheckButton",nil, framemain, "UICheckButtonTemplate")
	checkboxdouble:SetPoint("TOPLEFT", 180, -50)
	checkboxdouble.type = "checkbox"
	checkboxdouble:SetChecked(true)
	checkboxdouble.text:SetText(L10N.OptSDoubleFlag)
	checkboxdouble:SetScript("OnClick", CBDouble_OnClick)
	
	local labelBarHeight =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarHeight:SetPoint("TOPLEFT", 20, -80)
	labelBarHeight:SetJustifyH("LEFT")
	labelBarHeight:SetJustifyV("TOP")
	labelBarHeight:SetText(L10N.OptSBarHeight);	
	local barheight= CreateFrame("Slider", nil, framemain)
	barheight:SetOrientation("HORIZONTAL")
	barheight:SetWidth(150)
	barheight:SetHeight(14)
	barheight:SetHitRectInsets(0, 0, -10, 0)
	barheight:SetBackdrop(configSliderBackdrop)
	barheight:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	barheight:SetPoint("TOPLEFT", 20, -100)
	barheight:SetMinMaxValues(4, 100)
	barheight:SetValueStep(1)
	barheight:SetValue(70)
	barheight.obj="height"
	barheight:SetScript("OnValueChanged", Bar_OnScrollValueChanged)
	
	local labelBarWidth =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarWidth:SetPoint("TOPLEFT", 180, -80)
	labelBarWidth:SetJustifyH("LEFT")
	labelBarWidth:SetJustifyV("TOP")
	labelBarWidth:SetText(L10N.OptsBarWidth);	
	local barwidth= CreateFrame("Slider", nil, framemain)
	barwidth:SetOrientation("HORIZONTAL")
	barwidth:SetWidth(150)
	barwidth:SetHeight(14)
	barwidth:SetHitRectInsets(0, 0, -10, 0)
	barwidth:SetBackdrop(configSliderBackdrop)
	barwidth:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	barwidth:SetPoint("TOPLEFT", 180, -100)
	barwidth:SetMinMaxValues(20, 100)
	barwidth:SetValueStep(1)
	barwidth:SetValue(70)
	barwidth.obj="width"
	barwidth:SetScript("OnValueChanged", Bar_OnScrollValueChanged)
	
	local labelBarLine =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarLine:SetPoint("TOPLEFT", 20, -120)
	labelBarLine:SetJustifyH("LEFT")
	labelBarLine:SetJustifyV("TOP")
	labelBarLine:SetText(L10N.OptsBarLineSpace);	
	local barline= CreateFrame("Slider", nil, framemain)
	barline:SetOrientation("HORIZONTAL")
	barline:SetWidth(150)
	barline:SetHeight(14)
	barline:SetHitRectInsets(0, 0, -10, 0)
	barline:SetBackdrop(configSliderBackdrop)
	barline:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	barline:SetPoint("TOPLEFT", 20, -140)
	barline:SetMinMaxValues(0, 50)
	barline:SetValueStep(1)
	barline:SetValue(0)
	barline.obj="linespace"
	barline:SetScript("OnValueChanged", Bar_OnScrollValueChanged)
	
	
	local labelBarColumn =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelBarColumn:SetPoint("TOPLEFT", 180, -120)
	labelBarColumn:SetJustifyH("LEFT")
	labelBarColumn:SetJustifyV("TOP")
	labelBarColumn:SetText(L10N.OptsBarColumnSpace);	
	local barcolumn= CreateFrame("Slider", nil, framemain)
	barcolumn:SetOrientation("HORIZONTAL")
	barcolumn:SetWidth(150)
	barcolumn:SetHeight(14)
	barcolumn:SetHitRectInsets(0, 0, -10, 0)
	barcolumn:SetBackdrop(configSliderBackdrop)
	barcolumn:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	barcolumn:SetPoint("TOPLEFT", 180, -140)
	barcolumn:SetMinMaxValues(0, 50)
	barcolumn:SetValueStep(1)
	barcolumn:SetValue(0)
	barcolumn.obj="columnspace"
	barcolumn:SetScript("OnValueChanged", Bar_OnScrollValueChanged)
	
	local labelButtonLoc =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelButtonLoc:SetPoint("TOPLEFT", 20, -160)
	labelButtonLoc:SetJustifyH("LEFT")
	labelButtonLoc:SetJustifyV("TOP")
	labelButtonLoc:SetText(L10N.OptsIconLoc);	
	local barbuttonloc= CreateFrame("Slider", nil, framemain)
	barbuttonloc:SetOrientation("HORIZONTAL")
	barbuttonloc:SetWidth(150)
	barbuttonloc:SetHeight(14)
	barbuttonloc:SetHitRectInsets(0, 0, -10, 0)
	barbuttonloc:SetBackdrop(configSliderBackdrop)
	barbuttonloc:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	barbuttonloc:SetPoint("TOPLEFT", 20, -180)
	barbuttonloc:SetMinMaxValues(0, 7)
	barbuttonloc:SetValueStep(1)
	barbuttonloc:SetValue(0)
	barbuttonloc.obj="location"
	barbuttonloc:SetScript("OnValueChanged", BarButtonLoc_OnScrollValueChanged)
	
	local labelButtonLocSpace =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelButtonLocSpace:SetPoint("TOPLEFT", 180, -160)
	labelButtonLocSpace:SetJustifyH("LEFT")
	labelButtonLocSpace:SetJustifyV("TOP")
	labelButtonLocSpace:SetText(L10N.OptsIconSpace);	
	local brbuttonlocspace= CreateFrame("Slider", nil, framemain)
	brbuttonlocspace:SetOrientation("HORIZONTAL")
	brbuttonlocspace:SetWidth(150)
	brbuttonlocspace:SetHeight(14)
	brbuttonlocspace:SetHitRectInsets(0, 0, -10, 0)
	brbuttonlocspace:SetBackdrop(configSliderBackdrop)
	brbuttonlocspace:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	brbuttonlocspace:SetPoint("TOPLEFT", 180, -180)
	brbuttonlocspace:SetMinMaxValues(0, 50)
	brbuttonlocspace:SetValueStep(1)
	brbuttonlocspace:SetValue(0)
	brbuttonlocspace.obj="space"
	brbuttonlocspace:SetScript("OnValueChanged", BarButtonLoc_OnScrollValueChanged)
	
	
	local widget = {
		framemain	= framemain,
		checkboxdouble = checkboxdouble,
		barheight = barheight,
		barwidth = barwidth,
		barline = barline,
		barcolumn = barcolumn,
		barbuttonloc = barbuttonloc,
		brbuttonlocspace = brbuttonlocspace			
	}
	for method, func in pairs(methods) do
		widget[method] = func
	end
	return widget
end